package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.AmsPurchaseOrderMapper;
import com.steerinfo.dil.model.AmsPurchaseOrder;
import com.steerinfo.dil.service.IAmsPurchaseOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;

/**
 * AmsPurchaseOrder服务实现：
 * @author zouzhd
 * @version 1.0-SNAPSHORT 2021-08-19 09:22
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：AmsPurchaseOrder服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service
public class AmsPurchaseOrderServiceImpl implements IAmsPurchaseOrderService{

    @Autowired
    private AmsPurchaseOrderMapper amsPurchaseOrderMapper;

    /**
     * 采购订单生成
     * @param amsPurchaseOrder
     * @return
     */
    @Override
    public int insertAmsPurchaseOrder(AmsPurchaseOrder amsPurchaseOrder) {
        long id;
        if(amsPurchaseOrderMapper.selectMaxId()==null){
            id = 1;
        }else {
            id = amsPurchaseOrderMapper.selectMaxId().longValue()+1;
        }
        amsPurchaseOrder.setPurchaseOrderId(new BigDecimal(id));
        //WCGDD-年月日-8位数的顺序号
        Calendar now = Calendar.getInstance();
        String number = "WCGDD-" +  now.get(Calendar.YEAR);
        if (now.get(Calendar.MONTH)+1 < 10) {
            number = number + "0" + (now.get(Calendar.MONTH)+1);
        }
        else {
            number = number + now.get(Calendar.MONTH)+1;
        }
        number = number + now.get(now.DAY_OF_MONTH)+"-";
        switch ((new BigDecimal(id).toString()).length()) {
            case 1:
                number = number + "0000000" + id;
                break;
            case 2:
                number = number + "000000" + id;
                break;
            case 3:
                number = number + "00000" + id;
                break;
            case 4:
                number = number + "0000" + id;
                break;
            case 5:
                number = number + "000" + id;
                break;
            case 6:
                number = number + "00" + id;
                break;
            case 7:
                number = number + "0" + id;
                break;
            default:number = number + id;
        }
        amsPurchaseOrder.setPurchaseOrderNo(number);
        amsPurchaseOrder.setPurchaseOrderDate(new Date());
        amsPurchaseOrder.setInsertUsername("admin");
        amsPurchaseOrder.setInsertTime(new Date());
        amsPurchaseOrder.setUpdateUsername("admin");
        amsPurchaseOrder.setUpdateTime(new Date());
        amsPurchaseOrder.setInsertUpdateRemark("无");
        System.out.println(amsPurchaseOrder);
        return amsPurchaseOrderMapper.insert(amsPurchaseOrder);
    }

    /**
     * 通过主键删除采购订单
     * @param purchaseOrderId
     * @return
     */
    @Override
    public int deleteAmsPurchaseOrderByPurchaseOrderId(BigDecimal purchaseOrderId) {
        return amsPurchaseOrderMapper.deleteByPrimaryKey(purchaseOrderId);
    }

    /**
     * 通过主键修改采购订单
     * @param amsPurchaseOrder
     * @return
     */
    @Override
    public int updateAmsPurchaseOrderByPurchaseOrderId(AmsPurchaseOrder amsPurchaseOrder) {
        return amsPurchaseOrderMapper.updateByPrimaryKeySelective(amsPurchaseOrder);
    }

    /**
     * 通过主键查询采购订单
     * @param purchaseOrderId
     * @return
     */
    @Override
    public AmsPurchaseOrder getAmsPurchaseOrderByPurchaseOrderId(BigDecimal purchaseOrderId) {
        return amsPurchaseOrderMapper.selectByPrimaryKey(purchaseOrderId);
    }
}
